
(*s Arbres de syntaxe abstraite du Pascal. *)

type typ =
  | Tinteger
  | Tbool

type variable = string list * typ

type constant =
  | Cinteger of int
  | Cbool of bool

type binop =
  | Eq | Noteq | Gt | Ge | Lt | Le | And | Or

type unop =
  | Not

type expr =
  | Econstant of constant
  | Evar of string
  | Ebinop of expr * binop * expr
  | Eunop of unop * expr

type instr =
  | Iassign of string * expr
  | Icond of expr * block * block

and block = instr list

type param = variable

type proc_fun =
  | Procedure of string * param list * variable list * block
  | Function of string * param list * typ * variable list * block

type program = string * variable list * proc_fun list * block
